#!/bin/bash

clear

sudo rmmod can
sudo rmmod can-raw
sudo rmmod can-bcm
sudo rmmod vcan

# Load driver
sudo modprobe can
sudo modprobe can-raw
sudo modprobe can-bcm
sudo modprobe vcan

# Set bitrate to 125 kbit/s
BITRATE=125000

# Or to the given one
if [ "$1" == "250" -o "$1" == "1000" ]
then
	BITRATE=${1}000
	echo $BITRATE
fi

# Use the default CAN interface
INTERFACE=can0

# Or the given one
if [ "$2" != "" ]
then
	INTERFACE=can$2
fi

# Bring down the CAN interface
sudo ifconfig ${INTERFACE} down

sudo ip link set ${INTERFACE} type can bitrate ${BITRATE}

sudo ip link set ${INTERFACE} type can restart-ms 100

# Bring up the CAN interface
sudo ifconfig ${INTERFACE} up

# Show statistic
ip -det -stat link show ${INTERFACE}
