#ifndef ISEGHALREMOTE_H
#define ISEGHALREMOTE_H

#include "isegapi.h"

#include <QObject>

class QSslSocket;

class IsegHalRemote : public QObject
{
	Q_OBJECT

public:
	enum { DefaultNetworkTimeout = 5000 };

	IsegHalRemote(QObject *parent = 0);

	IsegResult isegConnect(const QString &session, const QString &interface);
	IsegResult isegDisconnect();
	IsegItem isegGetItem(const QByteArray &item);
	IsegResult isegSetItem(const QByteArray &item, const QByteArray &value);
	IsegItemProperty isegGetItemProperty(const QByteArray &item);
	quint32 isegGetServerVersion();
	QByteArray isegGetServerVersionString();

	static IsegItem isegErrorItem();
	static IsegItemProperty isegErrorProperty();
	static QByteArray isegResult(IsegResult value);
	static int timeout();
	static void setTimeout(int milliSeconds);
	static bool supportsSsl();

private:
	bool connectToHostEncrypted(const QString &host, quint16 port);
	QByteArray writeReadSynchronous(const QByteArray &data) const;
	QByteArray writeRead(char command, const QByteArray &value = QByteArray()) const;

	static int m_timeout;
	QByteArray m_session;
	QByteArray m_host;
	QSslSocket *m_socket;
};

#endif // ISEGHALREMOTE_H
