#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QByteArray>
#include <QList>
#include <QMainWindow>

#if (QT_VERSION < QT_VERSION_CHECK(5, 4, 0))
typedef QList<QByteArray> QByteArrayList;
#endif

namespace Ui {
class MainWindow;
}

class QSettings;
class QTimer;

class MainWindow : public QMainWindow
{
	Q_OBJECT

public:
	explicit MainWindow(QWidget *parent = 0);
	~MainWindow();

protected:
	void closeEvent(QCloseEvent *event);

private slots:
	void on_login_clicked();
	void on_buttonSend_clicked();
	void currentCommandChanged(const QString &newText);
	void on_timeout_valueChanged(int arg1);
	void on_selectScript_clicked();
	void on_runScript_clicked();
	void sendNextScriptLine();

private:
	QStringList sendCommand(const QString &command);
	QStringList getSettingValues(const QString &section);
	void appendSettingValue(const QString &section, const QString &value);
	void setSettingValues(const QString &section, const QStringList &values);
	void setFocusToCommand();

	bool m_connected;
	QByteArray m_session;
	QSettings *m_settings;
	QTimer *m_timer;
	QByteArrayList m_scriptLines;
	int m_currentScriptLine;
	Ui::MainWindow *ui;
};

#endif // MAINWINDOW_H
