#ifndef ISEGHALREMOTECONNECTION_H
#define ISEGHALREMOTECONNECTION_H

#include <QAbstractSocket>
#include <QObject>

class QSslSocket;

class IsegHalRemoteConnection : public QObject
{
	Q_OBJECT

public:
	IsegHalRemoteConnection(quint16 m_socket, QObject *parent = 0);
	~IsegHalRemoteConnection();

private slots:
	void ready();

public slots:
	void readData();
	void connectionClosed();
	void error(QAbstractSocket::SocketError err);

private:
	QByteArray isegConnect(const QByteArray &data);
	QByteArray isegDisconnect(const QByteArray &data);
	QByteArray isegGetItem(const QByteArray &data);
	QByteArray isegSetItem(const QByteArray &data);
	QByteArray isegGetProperty(const QByteArray &data);
	QByteArray isegGetVersion(const QByteArray &data);

	bool       m_authorized;
	QByteArray m_session;
	QSslSocket *m_socket;
};

#endif // ISEGHALREMOTECONNECTION_H
