#include "clientthread.h"

#include "isegremoteapi.h"

ClientThread::ClientThread(const QByteArray &session, const QByteArray &interface, const QByteArray &object, QObject *parent) :
	QThread(parent),
	m_session(session),
	m_interface(interface),
	m_object(object),
	m_success(false)
{
}

void ClientThread::run()
{
	m_success = (iseg_connect(m_session.constData(), m_interface.constData(), NULL) == ISEG_OK);
	if (!m_success)
		return;

	for (int i = 0; i < 5000; ++i) {
		const IsegItem item = iseg_getItem(m_session.constData(), m_object.constData());

		if (strcmp(item.object, m_object.constData())) {
			m_success = false;
			break;
		}

		if (strcmp(item.quality, ISEG_ITEM_QUALITY_OK)) {
			m_success = false;
			break;
		}
	}

	m_success &= (iseg_disconnect(m_session.constData()) == ISEG_OK);
}

bool ClientThread::success()
{
	return m_success;
}

