#ifndef ISEGHAL_H
#define ISEGHAL_H

#include "isegcommon.h"

#include <QString>

class IsegHal
{
public:
	IsegHal();
	virtual ~IsegHal();

	virtual unsigned int getVersion(void) = 0;
	virtual const char *getVersionString(void) = 0;

	virtual IsegResult connect(const QString &interface, bool firstConnection) = 0;
	virtual IsegResult disconnect() = 0;

	virtual IsegResult setValue(const IsegItem *item) = 0;
	virtual IsegItem getValue(const char *object) = 0;

	virtual IsegItemProperty getProperty(const char *object) = 0;

	QString getInterface() const;

protected:
	void setInterface(const QString &interface);

private:
	QString m_interface;
};

#endif // ISEGHAL_H
