#ifndef KCANAPI_H
#define KCANAPI_H

#ifdef __cplusplus
	extern "C" {
#endif

#include "isegcommon.h"
#include <stdbool.h>

#define CRATE_ADDESS_OFFSET 1000
#define CRATE_ECH238_ADDESS_OFFSET 2000

#define CAN_STATE_ERROR_ACTIVE_STRING    "00"	/* RX/TX error count < 96 */
#define CAN_STATE_ERROR_WARNING_STRING   "01"	/* RX/TX error count < 128 */
#define CAN_STATE_ERROR_PASSIVE_STRING   "02"	/* RX/TX error count < 256 */
#define CAN_STATE_BUS_OFF_STRING         "03"	/* RX/TX error count >= 256 */
#define CAN_STATE_STOPPED_STRING         "04"	/* Device is stopped */
#define CAN_STATE_SLEEPING_STRING        "05"	/* Device is sleeping */
#define CAN_STATE_SERIOUSLY_ERROR_STRING "06"	/* Cannot get bustate -something is seriously wrong */

#define STATE_UNDEFINED_STRING       "99"

unsigned int can_getVersion(void);
const char *can_getVersionString(void);
IsegResult can_connect(const char *interface, bool firstConnection);
IsegResult can_disconnect(void);
IsegResult can_setItemValue(const IsegItem *item);
IsegItem can_getItemValue(const char *object);
IsegItemProperty can_getItemProperty(const char *object);

#ifdef __cplusplus
	}
#endif

#endif // KCANAPI_H
