#ifndef CHANNEL_H
#define CHANNEL_H

#include <stdint.h>

#include "isegcommon.h"
#include "kisegtype.h"
#include "kedcp_can_dataid.h"

typedef struct ItemValue {
	uint32_t value;
	uint32_t valueSet;
	char quality[QUALITY_SIZE];
	char timeStampLastRefreshed[TIME_SIZE];
	char timeStampLastChanged[TIME_SIZE];
	ElementState state;
} ItemValue;

typedef enum KDataCacheChannelColumn {
	DataCacheColumnChannelStatus = 0,
	DataCacheColumnChannelTemperatureExternal,
	DataCacheColumnChannelControl,
	DataCacheColumnChannelEventStatus,
	DataCacheColumnChannelEventMask,
	DataCacheColumnChannelDelayedTripAction,
	DataCacheColumnChannelDelayedTripTime,
	DataCacheColumnChannelExternalInhibitAction,
	DataCacheColumnChannelVoltageSet,
	DataCacheColumnChannelCurrentSet,
	DataCacheColumnChannelVoltageBounds,
	DataCacheColumnChannelCurrentBounds,
	DataCacheColumnChannelVctCoefficient,
	DataCacheColumnChannelVoltageMeasure,
	DataCacheColumnChannelCurrentMeasure,
	DataCacheColumnChannelVoltageNominal,
	DataCacheColumnChannelCurrentNominal,
	DataCacheColumnChannelSize
} KDataCacheChannelColumn;

#endif // CHANNEL_H

KDataCacheChannelColumn kchannel_columnForDataId(KEdcpDataId dataId);
void kchannel_setReceivedValue(uint32_t value, uint16_t line, uint16_t module, uint16_t channel, KDataCacheChannelColumn column);
KCanMessage kchannel_canMessageValue(uint16_t line, uint16_t module, uint16_t channel, uint16_t column);
KCanMessage kchannel_requestMessageValue(uint16_t line, uint16_t module, uint16_t channel, uint16_t column);
void kchannel_setOffInConsequenceFromCrateControl(uint16_t line, uint16_t module, uint16_t channel, uint16_t column);
