#ifndef KCRATES_ECH4X_H
#define KCRATES_ECH4X_H

#include "kisegtype.h"
#include "kedcp_can_dataid.h"

#define CRATE_ADDRESS_OFFSET 1000

typedef struct CrateCache {
	TimeOut  timeOut;
	bool     logOn;
	bool     alive;
	uint32_t status;
	uint32_t control;
	uint32_t controlSet;
	uint32_t eventStatus;
	uint32_t eventStatusSet;
	uint32_t eventMask;
	uint32_t eventMaskSet;
	float    fanSpeed;
	bool     powerOn;
	bool     powerOnSet;
	uint32_t serialNumber;
	uint8_t  deviceClass;
	char     firmwareRelease[4];
	char     firmwareName[EDCP_MAX_STRING_LENGTH];
	float    temperatures[INTERNAL_TEMPERATURE_ARRAY_SIZE];
	float    supplies[VCC_ARRAY_SIZE];
	char     article[EDCP_GROUP_MAX_STRING_LENGTH];
	uint32_t backPlaneType;
	uint16_t lowPriorityCounter;
	char     identifierList[15];
} CrateCache;
#define EmptyCrateCache { EmptyTimeOut, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, { 0 }, { 0 } }

typedef enum KDataCacheCrateColumn {
	DataCacheColumnCrateLogOn = 0,
	DataCacheColumnCrateAlive,
	DataCacheColumnCrateStatus,
	DataCacheColumnCrateControl,
	DataCacheColumnCrateEventStatus,
	DataCacheColumnCrateEventMask,
	DataCacheColumnCrateFanSpeed,
	DataCacheColumnCratePowerOn,
	DataCacheColumnCrateSerialNumber,
	DataCacheColumnCrateDeviceClass,
	DataCacheColumnCrateFirmwareRelease,
	DataCacheColumnCrateFirmwareName,
	DataCacheColumnCrateTemperatures,
	DataCacheColumnCrateSupplies,
	DataCacheColumnCrateArticle,
	DataCacheColumnCrateIdetifierList,
	DataCacheColumnCrate4xaSize,
	ExtendedColumnCrateBackPlaneType,
	DataCacheColumnCrateSupplyPositiveExtern,
	DataCacheColumnCrateSupplyLogicExtern,
	DataCacheColumnCrateSupplyBattery,
	DataCacheColumnCrateTemperatureSensor2,
	DataCacheColumnCrate238Size
} KDataCacheCrateColumn;

typedef struct ItemPropertyCrate {
	char     objectString[OBJECT_NAME_SIZE];
	uint16_t dataId;
	KDataCacheCrateColumn column;
	DataType type;
	char     typeString[DATA_TYPE_SIZE];
	char     unit[UNIT_SIZE];
	char     accessRights[ACCESS_SIZE];
} ItemPropertyCrate;

bool kcrate_isEch4x(uint16_t line, uint16_t crate);
void kcrate_setCanMessageValue(const KCanMessage *rxMsg);
KCanMessage kcrate_handler(uint32_t *preConfiguredCounter, KCollectData *collectData);

#endif // KCRATES_ECH4X_H
