#ifndef KISEGTYPE
#define KISEGTYPE

#include "isegcommon.h"
#include "kcan.h"

typedef enum ElementState{
	unused = 0,
	waitForInitialData,
	communicationBad,
	actual,
	newValueLowPriority,
	newValueHighPriority,
	waitForRequest1,
	waitForRequest2,
	waitForRequest3,
	waitForRequest4,
	waitForRequest5,
	waitForRequest6,
	waitForRequest7,
	waitForRequest8,
	waitForRequest9,
	waitForRequest10,
	waitForRequest11,
	waitForRequest12,
	waitForRequest13,
	waitForRequest14,
	waitForRequest15,
	waitForRequest16,
	waitForRequest17,
	waitForRequest18,
	waitForRequest19,
	waitForRequest20,
	waitForRequest21,
	waitForRequest22,
	waitForRequest23,
	waitForRequest24,
	waitForRequest25,
	waitForRequest26,
	waitForRequest27,
	waitForRequest28,
	waitForRequest29,
	waitForRequest30,
	waitForRequest31,
	waitForRequest32,
	waitForRequest33,
	waitForRequest34,
	waitForRequest35,
	waitForRequest36,
	waitForRequest37,
	waitForRequest38,
	waitForRequest39,
	waitForRequest40,
	waitForRequest41,
	waitForRequest42,
	waitForRequest43,
	waitForRequest44,
	waitForRequest45,
	waitForRequest46,
	waitForRequest47,
	waitForRequest48,
	lastWaitForRequest,
	request
} ElementState;

typedef enum CacheState {
	state_notLogged = 0,
	state_logOff,
	state_configure,
	state_uninitialized,
	state_waitForAnswer,
	state_requestVariableData
} CacheState;

typedef struct TimeOut {
	KCanId canId;
	uint16_t dataId;
	uint32_t time;
	uint16_t answers;
	CacheState cacheState;
} TimeOut;
#define EmptyTimeOut { { 0 }, 0, 0, 0, 0 }

typedef enum DataType {
	DataTypeUI1,
	DataTypeUI4,
	DataTypeR4,
	DataTypeString,
	DataTypeBool,
	DataTypeNone
} DataType;

typedef enum KDataCacheColumn {
	DataCacheColumn0 = 0,
	DataCacheColumn1,
	DataCacheColumn2,
	DataCacheColumn3,
	DataCacheColumn4,
	DataCacheColumn5,
	DataCacheColumn6,
	DataCacheColumn7,
	DataCacheColumn8,
	DataCacheColumn9,
	DataCacheColumn10,
	DataCacheColumn11,
	DataCacheColumn12,
	DataCacheColumn13,
	DataCacheColumnSize
} KDataCacheColumn;

typedef struct ItemProperty {
	char     objectString[OBJECT_NAME_SIZE];
	uint16_t dataId;
	KDataCacheColumn column;
	DataType type;
	char     typeString[DATA_TYPE_SIZE];
	char     unit[UNIT_SIZE];
	char     accessRights[ACCESS_SIZE];
} ItemProperty;

typedef enum CommunicationSystem {
	state_init = 0,
	state_disconnect_0,
	state_disconnect_1,
	state_preConfigured,
} CommunicationSystem;

typedef uint16_t KEdcpDataId;
typedef uint8_t KDcpDataId;

typedef union FloatInt {
	uint32_t uintVal;
	float floatVal;
} FloatInt;

extern inline float toFloat(uint32_t value);
extern inline uint32_t toUint(float value);

typedef enum KCollectData {
	CollectEhsModuleData = 0,
	CollectEhqModuleData,
	CollectCrateData,
	Collect238CrateData,
	CollectDataSize
} KCollectData;

#endif // KISEGTYPE

