#include "kline.h"

#include <string.h>

LineCache m_lineCacheValue[DataCacheMaxLines] = { 0 }; //EmptyLineCache;
char m_lineCacheTimeStampLastRefreshed[DataCacheMaxLines][DataCacheColumnLineSize][TIME_SIZE] = { { { 0 } } };
char m_lineCacheTimeStampLastChanged[DataCacheMaxLines][DataCacheColumnLineSize][TIME_SIZE] = { { { 0 } } };
char m_lineCacheQuality[DataCacheMaxLines][DataCacheColumnLineSize][QUALITY_SIZE] = { { { 0 } } };
ElementState m_lineCacheState[DataCacheMaxLines][DataCacheColumnLineSize] = { { 0 } };
const ItemProperty m_lineItemProperties[DataCacheColumnLineSize] = {
	{ "Status",           0,                                  DataCacheColumnLineCanStatus,       DataTypeString, "STR", "",    "R" },
	{ "BitRate",          0,                                  DataCacheColumnLineCanBitRate,      DataTypeUI4   , "UI4", "b/s", "R" },
	{ "ModuleNumber",     0,                                  DataCacheColumnLineModuleNumber,    DataTypeUI4,    "UI4", "",    "R" },
	{ "ModuleList",       0,                                  DataCacheColumnLineModuleList,      DataTypeString, "STR", "",    "R" },
	{ "CrateNumber",      0,                                  DataCacheColumnLineCrateNumber,     DataTypeUI4,    "UI4", "",    "R" },
	{ "CrateList",        0,                                  DataCacheColumnLineCrateList,       DataTypeString, "STR", "",    "R" }
};

uint8_t kline_moduleNumber(uint16_t line)
{
	uint8_t i, moduleNumber;
	uint8_t length = strlen(m_lineCacheValue[line].moduleList);

	if (length == 0)
		return 0;

	moduleNumber = 1;
	for (i = 0; i < length; i++) {
		if (m_lineCacheValue[line].moduleList[i] == ',')
			moduleNumber++;
	}

	return moduleNumber;
}
