#ifndef KLOGGERFIFO_H
#define KLOGGERFIFO_H

#ifdef __cplusplus
	extern "C" {
#endif

#include "kcan.h"

#include <stdbool.h>
#include <stdint.h>

#define LOGGER_MESSAGE_SIZE 96
#define LOGGER_FIFO_CAPACITY 50

typedef char KLoggerMessage[LOGGER_MESSAGE_SIZE];

typedef struct KLoggerFifo {
	uint8_t head;		///< Pointer to last dequeued element
	uint8_t tail;		///< Pointer to last enqueued element
	uint8_t size;		///< Current number of elements in buffer
	uint8_t capacity;	///< Maximum number of elements in buffer
	KLoggerMessage *data; ///< Pointer to actual buffer data field
} KLoggerFifo;


void kloggerfifo_init(KLoggerFifo *self, KLoggerMessage *buffer, uint8_t capacity);
void kloggerfifo_setLevel(uint32_t level);
void kloggerfifo_setMessage(uint32_t event, char *info, uint16_t line, uint16_t device);
void kloggerfifo_setApiInfo(uint32_t event, char *info, const IsegItem *item);
void kloggerfifo_setFrame(uint32_t event, char *info, const KCanMessage *frame, int count, uint32_t answers);
bool kloggerfifo_getInfo(char **message);

#ifdef __cplusplus
	}
#endif

#endif // KLOGGERFIFO_H
