#ifndef KMODULES_H
#define KMODULES_H

#include "kisegtype.h"
#include "kedcp_can_dataid.h"

typedef enum ModuleLogOn {
	BoardASingleModule = 0,
	BoardBModule = 1,
	BoardBSingleModule1 = 2,
	BoardBSingleModule2 = 3
} ModuleLogOn;

typedef struct ModuleCache {
	TimeOut  timeOut;
	bool     logOn[4];
	bool     alive;
	bool     updated;
	uint32_t status;
	uint32_t control;
	uint32_t controlSet;
	uint32_t eventStatus;
	uint32_t eventStatusSet;
	uint32_t eventMask;
	uint32_t eventMaskSet;
	uint16_t sampleRate;
	uint16_t sampleRateSet;
	uint16_t digitalFilter;
	uint16_t digitalFilterSet;
	float    voltageRampSpeed;
	float    voltageRampSpeedSet;
	float    currentRampSpeed;
	float    currentRampSpeedSet;
	float    voltageLimit;
	float    currentLimit;
	float    temperature;
	uint32_t serialNumber;
	uint8_t  channelNumber;
	uint16_t channelMask;
	uint8_t  deviceClass;
	char     firmwareRelease[4];
	char     firmwareName[EDCP_MAX_STRING_LENGTH];
	float    temperatures[INTERNAL_TEMPERATURE_ARRAY_SIZE];
	float    supplies[VCC_ARRAY_SIZE];
	char     highVoltageOk[EDCP_MAX_STRING_LENGTH];
	char     highVoltageOkSet[EDCP_MAX_STRING_LENGTH];
	char     article[EDCP_GROUP_MAX_STRING_LENGTH];
	uint16_t lowPriorityCounter;
	uint16_t downCounterLogOn;
	uint16_t option;
	uint32_t counterSetValuesChanged;
	char     identifierList[15];
} ModuleCache;
#define EmptyModuleCache { EmptyTimeOut, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, { 0 }, { 0 }, { 0 }, { 0 }, { 0 }, { 0 }, 0 }

typedef enum KDataCacheModuleColumn {
	DataCacheColumnModuleLogOn = 0,
	DataCacheColumnModuleAlive,
	DataCacheColumnModuleStatus,
	DataCacheColumnModuleControl,
	DataCacheColumnModuleEventStatus,
	DataCacheColumnModuleEventMask,
	DataCacheColumnModuleSampleRate,
	DataCacheColumnModuleDigitalFilter,
	DataCacheColumnModuleVoltageRampSpeed,
	DataCacheColumnModuleCurrentRampSpeed,
	DataCacheColumnModuleVoltageLimit,
	DataCacheColumnModuleCurrentLimit,
	DataCacheColumnModuleSupplyP5,
	DataCacheColumnModuleSupplyP24,
	DataCacheColumnModuleTemperature,
	DataCacheColumnModuleSerialNumber,
	DataCacheColumnModuleChannelNumber,
	DataCacheColumnModuleDeviceClass,
	DataCacheColumnModuleFirmwareRelease,
	DataCacheColumnModuleFirmwareName,
	DataCacheColumnModuleTemperatures,
	DataCacheColumnModuleSupplies,
	DataCacheColumnModuleHighVoltageOk,
	DataCacheColumnModuleArticle,
	DataCacheColumnModuleIdentifierList,
	DataCacheColumnModuleSize,

	ExtendedColumnModuleControl2,
	ExtendedColumnModuleStatus2,
	ExtendedColumnModuleEventStatus2,
	ExtendedColumnModuleDeviceClass2,
	ExtendedColumnModuleSetValuesChanged,
	ExtendedColumnModuleSize
} KDataCacheModuleColumn;

void kmodule_setCanMessageValue(const KCanMessage *rxMsg);
uint16_t kmodule_channelNumber(uint16_t line, uint16_t module);
KCanMessage kmodule_handler(uint32_t *preConfiguredCounter, KCollectData *collectData);

#endif // KMODULES_H
