#include "kstring.h"
#include "isegcommon.h"

void *memrcpy(void *dst, const void *src, size_t count)
{
	void * ret = dst;

	/* Low Endian to Big Endian
	 * copy from lower addresses to higher addresses
	 */
	src = (char *)src+(count-1);
	while (count--) {
		*(char *)dst = *(char *)src;
		dst = (char *)dst + 1;
		src = (char *)src - 1;
	}
	return(ret);
}

uint32_t bitArrayIndexedValue(uint32_t *destinationValue, uint32_t sourceValue, uint8_t index)
{
	if (index >= NO_BIT_ARRAY_INDEX)
		return sourceValue;

	return (sourceValue) ? *destinationValue | (1 << index) : *destinationValue & ~(1 << index);
}
