#include "ksystem.h"
#include "kline.h"
#include "kmodules.h"

SystemCache m_systemCacheValue = { 0 }; //EmptyLineCache;
char m_systemCacheTimeStampLastRefreshed[DataCacheColumnSystemSize][TIME_SIZE] = { { 0 } };
char m_systemCacheTimeStampLastChanged[DataCacheColumnSystemSize][TIME_SIZE] = { { 0 } };
char m_systemCacheQuality[DataCacheColumnSystemSize][QUALITY_SIZE] = { { 0 } };
ElementState m_systemCacheState[DataCacheColumnSystemSize] = { 0 };
const ItemProperty m_systemItemProperties[DataCacheColumnSystemSize] = {
	{ "Status",           0,                                  DataCacheColumnSystemCanStatus,       DataTypeString, "STR", "",    "R" },
	{ "BitRate",          0,                                  DataCacheColumnSystemCanBitRate,      DataTypeUI4   , "UI4", "b/s", "R" },
	{ "CrateNumber",      0,                                  DataCacheColumnSystemCrateNumber,     DataTypeUI4,    "UI4", "",    "R" },
	{ "CrateList",        0,                                  DataCacheColumnSystemCrateList,       DataTypeString, "STR", "",    "R" },
	{ "ModuleNumber",     0,                                  DataCacheColumnSystemModuleNumber,    DataTypeUI4,    "UI4", "",    "R" },
	{ "CycleCounter",     0,                                  DataCacheColumnSystemCycleCounter,    DataTypeUI4,    "UI4", "",    "R" },
	{ "Configuration",    0,                                  DataCacheColumnSystemConfiguration,   DataTypeUI4,    "UI2", "",    "RW"},
	{ "Read",             0,                                  DataCacheColumnSystemRead,            DataTypeString, "STR", "",    "RW"},
	{ "Write",            0,                                  DataCacheColumnSystemWrite,           DataTypeString, "STR", "",    "W"},
	{ "LogLevel",         0,                                  DataCacheColumnSystemLogLevel,        DataTypeUI4,    "UI4", "",    "RW"},
	{ "LogPath",          0,                                  DataCacheColumnSystemLogPath,         DataTypeString, "STR", "",    "RW"},
};

extern LineCache m_lineCacheValue[DataCacheMaxLines];

uint8_t ksystem_moduleNumber(void)
{
	uint8_t moduleNumber = 0;
	uint16_t line ;

	for (line = 0; line < DataCacheMaxLines; line++) {
		moduleNumber += kline_moduleNumber(line);
	}

	return moduleNumber;
}

uint8_t ksystem_requestDelay(void)
{
	return waitForRequest47 - (waitForRequest47 - waitForRequest1) / ksystem_moduleNumber();
}
