#ifndef SYSTEM_H
#define SYSTEM_H

#include <stdint.h>

#include "isegcommon.h"
#include "kisegtype.h"

typedef union KDeviceConfiguration {
	uint32_t word;
	struct bit {
		uint32_t modeTunnel: 1;
		uint32_t modeUpdate: 1;
	} bit;
} KDeviceConfiguration;

typedef struct SystemCache {
	uint8_t  crateNumber;
	char     crateList[VALUE_SIZE];
	uint32_t moduleNumber;
	uint32_t cycleCounter;
	KDeviceConfiguration configuration;
	char     read[MAX_READ_MESSAGES][WRITE_READ_SIZE];
	char     write[WRITE_READ_SIZE];
	uint32_t logLevel;
	char     logPath[VALUE_SIZE];
} SystemCache;

typedef enum KDataCacheSystemColumn {
	DataCacheColumnSystemCanStatus = 0,
	DataCacheColumnSystemCanBitRate,
	DataCacheColumnSystemCrateNumber,
	DataCacheColumnSystemCrateList,
	DataCacheColumnSystemModuleNumber,
	DataCacheColumnSystemCycleCounter,
	DataCacheColumnSystemConfiguration,
	DataCacheColumnSystemRead,
	DataCacheColumnSystemWrite,
	DataCacheColumnSystemLogLevel,
	DataCacheColumnSystemLogPath,
	DataCacheColumnSystemSize
} KDataCacheSystemColumn;

uint8_t ksystem_moduleNumber(void);
uint8_t ksystem_requestDelay(void);

#endif // SYSTEM_H
